//  written by Zheng Gengbin
//  deal with assignment
//  and pointer assignment

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#include "compilerApi.h"
#include "strategy.h"

#include "anls_att.h"

extern char *func_name_search(SgFunctionCallExp *);
extern void trans_funccall(SgStatement * ,SgExpression *);

extern SgExpression *get_first_address(SgStatement *s,SgArrayRefExp * arrayexp);

extern void sum_communication(enum Communication comm);

// expr.cc
extern SgExpression *get_scalar_subscripts(SgStatement *s,SgArrayRefExp *arrayexp);
extern void  analyse_array_ref_in_exp_without_oc_read(SgStatement *s,SgExpression *exp,SgStatement *where);

// task.cc
extern SgStatement * wrap_by_on_clause(SgStatement *, SgStatement *);
extern int need_wrap_on_clause();

extern int element_intrinsic_call;

#define DEMO 0

assign_reference::assign_reference(Position s)
{
  side =s;
  status = NONE;
  sameAs=-1;
}

Position assign_reference::position()
{
  return side;
}

void assign_reference::setExpression(SgExpression * e)
{
  expr=e;
}

SgExpression * assign_reference::expression()
{
  return expr;
}

void assign_reference::setCommunication(Communication c)
{
  status=c;
}

Communication assign_reference::getCommunication()
{
  return status;
}

void assign_reference::show()
{
}

//-----------------------------------------------;


void add_assign_reference(SgAssignStmt * assign, SgExpression * exp, Position side)
{
  switch (exp->variant()) {

  case ADD_OP:
  case MINUS_OP:
  case MULT_OP:
  case DIV_OP:
  case MOD_OP: {
    add_assign_reference(assign, exp->operand(1), side);
    if ( exp->operand(2))
	add_assign_reference(assign, exp->operand(2), side);
    break;
  }

  case VAR_REF:
  case ARRAY_REF: {
      // already in NODE status.
    if ( !exp->haveAttribute(NODE_CODE_BIT)) 
    {
    assign_reference * aref = new assign_reference(side);
    aref->setExpression(exp);
    assign->addAttribute(Assign_Ref,(void *)aref, sizeof(assign_reference));
    }
    break;
  }

  case INT_VAL:
  case FLOAT_VAL:
  case BOOL_VAL:
  case STRING_VAL: {
    // do nothing;
    break;
  }
  
  case FUNC_CALL:  {
// add by zheng.gb
    assign->addAttribute(Funccall_Ref,exp,sizeof(exp) );
    break;
  }

  case INTRIN_FUNC_CALL: {
    // here is a junck code, just for demo;
    //assign->addAttribute(DEMO, NULL, 0);
// add by zheng.gb
//    assign->addAttribute(Funccall_Ref,exp,sizeof(exp) );  1997/9/20
// wjp  do intrinsic function search !
//    replace_intrinsic_function_name(exp,0);		1997/9/20

      SgFunctionRefExp * funExp = (SgFunctionRefExp *) exp;
      // we use special method to deal with the dummy of elementary intrinsic function.
      if (((SgFunctionSymb*)funExp->symbol())->is_elementary_function()==1)
      {
	   // look the actual arg as an array
      	for (int i=0; i<funExp->numberOfArgs(); i++) 
      	   add_assign_reference(assign, funExp->arg(i), side);
      }
    
    break;
  }

  default:
    if (!silentFlag)
    printf("In add_assign_reference, unexpected expression on line %d, id: %d, variant: %d\n",assign->lineNumber(), exp->id(),exp->variant());
    break;
  }
  
}

void detect_assign_reference(SgAssignStmt * assign)
{
  // left is also considered .  
  for (int i=0; i<assign->numberOfAttributes(Assign_Ref); i++) {
      assign_reference *aref = (assign_reference *)assign->attributeValue(i, Assign_Ref);
      if ( aref->expression()->variant()==ARRAY_REF )
      {
      	SgSymbol *arraysymb = aref->expression()->symbol();
      	if (expr_no_communication(assign, arraysymb) == 1)
      		aref->setCommunication(NONE);
        else
      		aref->setCommunication(REMAP);
      }
  }
/*
  if (leftref->expression()->variant()==VAR_REF) {
    for (int i=1; i<assign->numberOfAttributes(Assign_Ref); i++) {
      assign_reference * aref = (assign_reference *) ((assign->getAttribute(i, Assign_Ref))->getAttributeData());
      if ( aref->expression()->variant()==ARRAY_REF )
      	aref->setCommunication(REMAP);
    }
  }
  else { // this is an array;
    printf("Crazy !!\n");
    if (leftref->expression()->symbol()->numberOfAttributes(Align_Def)==0) {
      if (leftref->expression()->symbol()->numberOfAttributes(Inherit_Def)==0) {
	for (int i=1; i<assign->numberOfAttributes(Assign_Ref); i++) {
	  assign_reference * aref = (assign_reference *) ((assign->getAttribute(i, Assign_Ref))->getAttributeData());
	  aref->setCommunication(REMAP);
	}
      }
      else {            // after trans1, I think this will never happen .
	printf("detect_assign_reference:not finished yet!\n");
      }
    }
    else {
      printf("detect_assign_reference:not finished yet!\n");
    }
  }
*/
}

void analyse_assign(SgStatement * s)
{
  SgAssignStmt * assign = (SgAssignStmt *) s;

  add_assign_reference(assign, assign->lhs(), left);

  add_assign_reference(assign, assign->rhs(), right);

  detect_assign_reference(assign);

  assign_reference * leftref = (assign_reference *) assign->attributeValue(0, Assign_Ref);

/*
  if ((leftref->expression()->variant()==VAR_REF) ||
      ((leftref->expression()->symbol()->numberOfAttributes(Align_Def)==0)&&
       (leftref->expression()->symbol()->numberOfAttributes(Inherit_Def)==0))) 
  {

    for (int i=1; i<assign->numberOfAttributes(Assign_Ref); i++) {
      assign_reference * aref = (assign_reference *) ((assign->getAttribute(i, Assign_Ref))->getAttributeData());
     
      if (aref->getCommunication()==REMAP) {
	if (leftref->expression()->symbol()->numberOfAttributes(NeedDad_Def)==0)
	{
	  leftref->expression()->symbol()->addAttribute(NeedDad_Def, NULL, 0);
	  break;
	}
      }
    }
  }
*/

}

// create sdd , set_array_scalar
void create_section(SgAssignStmt * assign, int counter)
{
  assign_reference * aref = (assign_reference *) ((assign->getAttribute(counter, Assign_Ref))->getAttributeData());
  
  SgArrayRefExp * array = (SgArrayRefExp *) aref->expression();
  SgSymbol * arraysymb  = aref->expression()->symbol();

  {
    SgSymbol * dadsec=assign->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
    SgSymbol * dad = assign->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    SgStatement  *assignStmt = make_new_array_section(assign, dadsec, 0 , dad);
    
    assign->insertStmtBefore(*assignStmt, * assign->controlParent());
  }

  for (int i=0; i<array->numberOfSubscripts(); i++) {
    if (1) {
      	SgSymbol * dadsymb = assign->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
      	SgExpression * scalar = ( (SgArrayRefExp *) aref->expression() )->subscript(i);
        SgSymbol * dad = assign->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
	int dim=i+1;
      	SgStatement *funcall = make_set_array_scalar(assign,dadsymb,scalar,dad,dim);
      	assign->insertStmtBefore(*funcall, *assign->controlParent());

    }
    else {
      printf("It should be a scalar on this dim\n");
    }

  }

  // call delete_array;
  {
    SgSymbol * dad = assign->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
    SgStatement * funcall = make_delete_array(assign , dad);
    assign->insertStmtAfter(*funcall, *assign->controlParent());
  }
}

void create_new(SgAssignStmt * assign, int counter)
{
  assign_reference * leftref = (assign_reference *)assign->attributeValue(0, Assign_Ref);
  SgSymbol * leftsymb = leftref->expression()->symbol();

  assign_reference * aref = (assign_reference *)assign->attributeValue(counter, Assign_Ref);
  SgArrayRefExp * array = (SgArrayRefExp *) aref->expression();
  SgSymbol * arraysymb  = aref->expression()->symbol();

  {
/*
    SgSymbol * symb = assign->getSymbolInCurrentScope(mixstring, "new_array_copy", NULL);
    SgFunctionRefExp * funcall = new SgFunctionRefExp (*symb);

    SgSymbol * stack = assign->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysymb->type()), NULL); 
    SgExpression * stackExp = new SgExpression(VAR_REF, NULL, NULL, stack);
    funcall->addArg(*stackExp);    
						       
	// ??? zheng.gb 	1997/6/27
    SgSymbol * secDad;
    if ( isSgArrayType(leftsymb->type()) )
    	secDad = assign->getSymbolInCurrentScope(mixstring, "dad", leftsymb->identifier());
    else
    	secDad = assign->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
    SgExpression * secDadExp=new SgExpression(VAR_REF, NULL, NULL, secDad);
    funcall->addArg(*secDadExp);

    SgSymbol * dadBase = assign->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgExpression * dadBaseExp=new SgExpression(VAR_REF, NULL, NULL, dadBase);

    SgAssignStmt * assignStmt = new SgAssignStmt(*dadBaseExp, *funcall);

    SgStatement * assignStmt = make_new_array_copy(s,dadBase,leftsymb);
  
    assign->insertStmtBefore(*assignStmt, *assign->controlParent());
*/

      // new_array_copy
    {
    SgSymbol *secDad = assign->getSymbolInCurrentScope(mixstring, "sdd", NULL, 0);
    SgSymbol *dadBase = assign->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgStatement * assignStmt = make_new_array_copy(assign,dadBase,secDad);
  
    assign->insertStmtBefore(*assignStmt, *assign->controlParent());
    }

/*
	// by zheng.gb pcrc_new_array_copy ==> pcrc_new_array_data  1997/9/15
    SgSymbol * symb = assign->getSymbolInCurrentScope(mixstring, "new_array_data", NULL);
    SgFunctionRefExp * funcall = new SgFunctionRefExp (*symb);

#ifdef MEM_ALLOC
    SgSymbol * stack = assign->getSymbolInCurrentScope(stackNameOfType(arraysymb->type()),"mb", NULL); 
#else
    SgSymbol * stack = assign->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysymb->type()), NULL); 
#endif
    SgExpression * stackExp = new SgExpression(VAR_REF, NULL, NULL, stack);
    funcall->addArg(*stackExp);    
						       
    SgSymbol * nametype = assign->getSymbolInCurrentScope(mixstring, nameOfType(arraysymb->type()), NULL); 
    SgExpression * nametypeExp = new SgExpression(VAR_REF, NULL, NULL, nametype);
    funcall->addArg(*nametypeExp);    
						       
    SgExpression * sizeExp = get_type_size(s, arraysymb->type());
    funcall->addArg(*sizeExp);    
						       
    SgValueExp *v0 = new SgValueExp(0);
    funcall->addArg(*v0);    
   
    SgSymbol * grp = assign->getSymbolInCurrentScope(mixstring, "grp_glob", NULL); 
    SgExpression * grpExp = new SgExpression(VAR_REF, NULL, NULL, grp);
    funcall->addArg(*grpExp);    

    SgSymbol * dadBase = assign->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgExpression * dadBaseExp=new SgExpression(VAR_REF, NULL, NULL, dadBase);

    SgAssignStmt * assignStmt = new SgAssignStmt(*dadBaseExp, *funcall);
  
    assign->insertStmtBefore(*assignStmt, *assign->controlParent());
*/
  }

  // allocate memory;
  SgSymbol * mHandle;
  {
    SgSymbol * base = assign->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
    SgSymbol * dadbase = assign->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);

#ifdef MEM_ALLOC
    	mHandle = assign->getSymbolInCurrentScope(mixstring, "mh", NULL, counter);
	SgStatement *alloc=make_stack_alloc(assign,arraysymb->type(),base,dadbase,mHandle);
#else
	SgStatement *alloc=make_alloc(assign,arraysymb->type(),base,dadbase);
#endif

    assign->insertStmtBefore(*alloc, *assign->controlParent());
  }

  // reset base;
  {
    SgSymbol * base = assign->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgSymbol * basesym = assign->getSymbolInCurrentScope(mixstring, "tbs", NULL,counter);

    SgStatement *funcall=make_reset_array_base(assign,base,arraysymb->type(),basesym,mHandle);

    assign->insertStmtBefore(*funcall, *assign->controlParent());
  }

  // call delete_array;
  {
    SgSymbol * symb = assign->getSymbolInCurrentScope(mixstring, "delete_array", NULL);
    SgCallStmt * funcall = new SgCallStmt (*symb);

    SgSymbol * base = assign->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgExpression * baseexpr=new SgVarRefExp(base);
    funcall->addArg(*baseexpr);
    
    assign->insertStmtAfter(*funcall, *assign->controlParent());
  }

  // call real free;
  {
#ifdef MEM_ALLOC
    SgSymbol * base = assign->getSymbolInCurrentScope(mixstring, "mh", NULL, counter);
#else
    SgSymbol * base = assign->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
#endif

    SgStatement * funcall = make_free(assign,arraysymb->type(),base);

    assign->insertStmtAfter(*funcall, *assign->controlParent());
  }

}

void add_remap(SgAssignStmt * assign, int counter)
{
  
  SgSymbol *dstsymb=assign->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
  SgSymbol *srcsymb=assign->getSymbolInCurrentScope(mixstring, "sdd", NULL , counter);
  SgStatement *funcall=make_remap(assign,dstsymb,srcsymb);

  assign->insertStmtBefore(*funcall, *assign->controlParent());
}


// add coef for ASSIGN
// flag=0:     do not insert , add as attributes
// flag=1:     really insert
void add_assign_coef(SgStatement * assign, int counter, int flag)
{
  assign_reference * aref = (assign_reference *)assign->attributeValue(counter, Assign_Ref);

  SgArrayRefExp * array = (SgArrayRefExp *) aref->expression();
  SgSymbol * arraysymb=array->symbol(); 

  for (int i=0; i<array->numberOfSubscripts(); i++) {
    SgSymbol * dad = assign->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    int dim = i+1;
/*
    SgExpression *l = array->subscript(i);
    SgExpression *u = array->subscript(i);
    SgExpression *s = new SgValueExp(1);
    SgValueExp * stride = new SgValueExp(1);
    SgValueExp * offset = new SgValueExp(0);
    SgStatement * call = make_coef(assign, dad, dim, l, u, s,
			stride,offset,new SgValueExp(0),counter,i);
*/
    SgExpression *l = array->subscript(i);
    SgSymbol * vsym = assign->getSymbolInCurrentScope(mixstring, "v", NULL, counter, i);
    SgStatement * call = make_offset(assign, dad, dim, l, vsym);

    if (flag)
      assign->insertStmtBefore(*call, *assign->controlParent());
    else
      assign->addAttribute(INDEX_INIT,call,sizeof(call));
  };
}


SgAssignStmt *wrap_assign_on(SgStatement * assign)
{
  int i;
  
  SgSymbol * lhssec = assign->getSymbolInCurrentScope(mixstring, "sdd", NULL, 0);
  SgExpression * grpexp = make_group(assign,lhssec);
  SgExpression * onexp = make_on(assign, grpexp);

  SgStatement *newassign = assign->copyPtr();
  SgStatement *ifstmt= new SgIfStmt(*onexp, *newassign);

/*
  SgStatement *coef = assign->nextInChildList();
  while (coef && isSgCallStmt(coef) && strcasecmp(isSgCallStmt(coef)->name()->identifier() ,"pcrc_coef")==0)
  {
	SgStatement *newcoef = coef->copyPtr();
  	newassign->insertStmtBefore(*newcoef, *newassign->controlParent());
	SgStatement *ss = coef;
  	coef = coef->nextInChildList();
	ss->deleteStmt();
  }
*/
  for (i=0; i<assign->numberOfAttributes(INDEX_INIT); i++) {
	SgStatement *coef = (SgStatement *)assign->attributeValue(i,INDEX_INIT);
	newassign->insertStmtBefore(*coef, *newassign->controlParent());
  }
  assign->insertStmtAfter(*ifstmt, *assign->controlParent());

    // insert pcrc_oc_write to write LHS element to LAF
  for (i=0; i<assign->numberOfAttributes(OC_ASSIGN); i++) {
	  SgStatement *oc_write = (SgStatement *)assign->attributeValue(i, OC_ASSIGN);
  	  newassign->insertStmtAfter(*oc_write,*newassign->controlParent());
  }

  assign->deleteStmt();

  return (SgAssignStmt *)newassign;
}

// change out of core all-collapsed arrayRef 
void change_oc_expression(SgStatement *s, SgArrayRefExp *array, int counter)
{
  	SgSymbol * arraysymb  = array->symbol();
	int i;

	SgExpression *vs = NULL;
	if (array_all_collapsed(arraysymb) == 1)
	{
	  vs = get_scalar_subscripts(s, array);
	}
	else
	for (i=0; i<array->numberOfSubscripts(); i++)
	{
      	   SgSymbol * vsym = s->getSymbolInCurrentScope(mixstring, "v", NULL, counter, i);
	   SgExpression *vexp = new SgVarRefExp(vsym);
	   vs = vs + (*vexp);
	}
//add by huang 98.3.12
	if(arraysymb->numberOfAttributes(Outofcore_Def)==0){
		SgArrayRefExp *newarray = new SgArrayRefExp(*arraysymb);
		newarray->addSubscript(*vs);
		array->replace(*newarray);
		if (unknown_address(arraysymb))
                        change_array_by_stack(s, array);
        }
        else{//case of out_of_core
		SgStatement *operation = NULL;
		SgExpression * buf=new SgValueExp(atoi(exp_level));
		buf=new SgExpression(EXPR_LIST,buf,NULL,NULL);
                SgArrayRefExp *memExp= (SgArrayRefExp *)array->copyPtr();
                memExp->setSubscripts(*buf);
		  // change if address unknown
		if (unknown_address(arraysymb))
			change_array_by_stack(s, memExp);
                SgSymbol *dad = s->getSymbolInCurrentScope(mixstring,"dad",
                        arraysymb->identifier());
                SgSymbol *stridesym = s->getSymbolInCurrentScope(mixstring,"oc_stride",arraysymb->identifier());
                SgSymbol *numbersym = s->getSymbolInCurrentScope(mixstring,"oc_number",arraysymb->identifier());
		  // insert as attribute, will cope later.
		if (counter == 0) {
                  operation = make_oc_write(s,dad,memExp,vs,stridesym,numbersym);
		  s->addAttribute(OC_ASSIGN, operation, sizeof(operation));
		}
		else {
                  operation = make_oc_read(s,dad,memExp,vs,stridesym,numbersym);
		}

		SgExpression *one=new SgValueExp(1);
                for(i=0;i<array->numberOfSubscripts();i++){
                        SgExpression *subscrpt=new SgValueExp(i+1);
                        subscrpt=new SgExpression(EXPR_LIST,subscrpt,NULL,NULL);
			SgArrayRefExp *numberexp=new SgArrayRefExp(numbersym->copy());
			numberexp->setSubscripts(*subscrpt);
                        SgAssignStmt *assignStmt=new SgAssignStmt(*numberexp, *one);
			if (counter == 0)
			s->addAttribute(OC_ASSIGN, assignStmt, sizeof(assignStmt));
			else
		  	s->insertStmtBefore(*assignStmt, *s->controlParent());
                }
		for(i=0;i<array->numberOfSubscripts();i++){
                        SgExpression *subscrpt=new SgValueExp(i+1);
                        subscrpt=new SgExpression(EXPR_LIST,subscrpt,NULL,NULL);                        SgArrayRefExp *stridexp=new SgArrayRefExp(stridesym->copy());
                        stridexp->setSubscripts(*subscrpt);
                        SgAssignStmt *assignStmt=new SgAssignStmt(*stridexp, *one);
			if (counter == 0)
                        s->addAttribute(OC_ASSIGN, assignStmt, sizeof(assignStmt));
			else
		  	s->insertStmtBefore(*assignStmt, *s->controlParent());
                }

		array->replace(*memExp);

		if (counter != 0 )
		  s->insertStmtBefore(*operation, *s->controlParent());

        }
//add by huang finished!
}

// flag = 0:  use u, v to caculate subscript
// flag = 1:  use stack 
void change_assign_reference(SgStatement * s, int counter, int flag)
{
  int i;
  assign_reference * aref = (assign_reference *)s->attributeValue(counter, Assign_Ref);
  SgArrayRefExp * array = (SgArrayRefExp *) aref->expression();
  SgSymbol * arraysymb  = aref->expression()->symbol();

  if (flag == 0)
  {
	change_oc_expression(s, array, counter);
  }
  else
  {
#ifdef MEM_ALLOC
  SgSymbol * stack = s->getSymbolInCurrentScope(stackNameOfType(arraysymb->type()), "mb",NULL); 
#else
  SgSymbol * stack = s->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysymb->type()), NULL); 
#endif
  SgArrayRefExp * stackExp = new SgArrayRefExp(* stack);
  
  SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
  SgExpression * baseexp=new SgVarRefExp(base);
  stackExp->addSubscript(*baseexp);
  array->replace(*stackExp);
  }

}

void trans_assign_reference(SgAssignStmt * assign, int counter)
{
  assign_reference * lhsaref = (assign_reference *)assign->attributeValue(0, Assign_Ref);
  assign_reference * aref = (assign_reference *)assign->attributeValue(counter, Assign_Ref);
  SgArrayRefExp * array = (SgArrayRefExp *) aref->expression();
  SgSymbol *arraysymb = array->symbol();

  if (aref->expression()->variant()!=ARRAY_REF) return;

   //// LHS
  if (counter==0) {
       // if all collapsed , then no need to wrap (pcrc_on) , and if no communication , no need to create pcrc_sdd0
      int need_sdd = 1;
      if (aref->getCommunication() == NONE)
      {
	int num=0;
	for (int i=0; i<assign->numberOfAttributes(Assign_Ref); i++) {
  		assign_reference * aref = (assign_reference *)assign->attributeValue(i, Assign_Ref);
		if (aref->getCommunication() == REMAP) num++;
	}
	if (num == 0) need_sdd=0;
      }
      if (need_sdd) create_section(assign, counter);
      if (aref->getCommunication() == NONE) {
	     // local , insert coef immediately
	if ( array_all_collapsed(arraysymb) != 1 ) 
      	   add_assign_coef(assign, counter, 1);  
      	change_assign_reference(assign, counter, 0);
      }
      else {
      	add_assign_coef(assign, counter, 0);  // add coef calls as attributes. donot insert
      	change_assign_reference(assign, counter, 0);
/*
	SgExpression *address = get_first_address(assign,array);
	SgArrayRefExp *newarray = new SgArrayRefExp(*arraysymb);
	newarray->addSubscript(*address);
	array->replace(*newarray);
*/
      }

  }
    /// RHS
  else {
    if (!silentFlag)
    printf("%s -- %s: ",lhsaref->expression()->symbol()->identifier(),arraysymb->identifier());
    if (debug_trans0)
      sum_communication(aref->getCommunication());
    switch (aref->getCommunication())
    {
    case NONE: {
	if (!silentFlag)
        printf("none(scalar_assign)\n");
	analyse_array_ref_in_exp_without_oc_read(assign,array,assign);
/*
	if (array_all_collapsed(arraysymb) == 1) {
	  analyse_array_ref_in_exp_without_oc_read(assign,array,assign);
	}
	else {  // must be local
	    // ASSERT (is_resident(arraysymb));
      	    add_assign_coef(assign, counter, 1);  
      	    change_assign_reference(assign, counter, 0);
	}
*/
	break;
       }
    case REMAP: {
	if (!silentFlag)
        printf("remap(scalar_assign)\n");
	switch (lhsaref->expression()->variant())  
	{
	case VAR_REF: {
	   analyse_array_ref_in_exp_without_oc_read(assign,array,assign);
	   break;
	  }
	case ARRAY_REF: {
	     // sdd
      	   create_section(assign, counter);
      	   create_new(assign, counter);
      	   add_remap(assign, counter);
      	   change_assign_reference(assign, counter, 1);
	   break;
	  }
	default:
	   ASSERT(0);
	}
      }
    }  // end switch
  };
}

void change_scalar_pointer(SgStatement * assign)
{
  for(int i=0;i<assign->numberOfAttributes(Assign_Ref);i++)
  {
	assign_reference * aref = (assign_reference *)assign->attributeValue(i,Assign_Ref);
	SgExpression *expr = aref->expression();
	if (expr->variant() != VAR_REF) continue;
	SgSymbol *symb = expr->symbol();
	if (!is_pointer(symb)) continue;
	change_variable_by_stack(assign, expr);
  }
}

/**************************************************************************
	trans_assign can process scalar assign statement include:
	1. LHS is a variable;
	2. LHS is an array reference(scalar)

optimization:
	1. if an array reference is all-collapsed, no need to communicate.
	2. if lhs array reference is all-collapsed, no need to wrap assign by pcrc_on()
**************************************************************************/
void trans_assign(SgStatement * s)
{
  int i;
  SgAssignStmt * assign = (SgAssignStmt *) s;

  for (i=0; i<assign->numberOfAttributes(Assign_Ref); i++) {
    trans_assign_reference(assign, i);
  }

    // change scalar pointer in assignment
  change_scalar_pointer(assign);

    // add by zheng.gb 1997/9/20
    // deal with intrinsic function
  if ( element_intrinsic_call == STACK_ELEMENT_INTRINSIC_CALL)
  {
  	analyse_intrinsic(assign,assign->expr(1),assign);
  }

    // add by zheng.gb
  for (i=0; i<assign->numberOfAttributes(Funccall_Ref); i++) 
  {
	SgExpression *funcall = (SgExpression *)assign->attributeValue(i,Funccall_Ref);
	trans_funccall(s,funcall);
  }

    // restrict the active process group
  assign_reference * lhsaref = (assign_reference *)assign->attributeValue(0, Assign_Ref);

//add by huang 98.3.24
  if(assign->controlParent()->variant()==LOGIF_STMT){
	  for(i=0;i<assign->numberOfAttributes(Assign_Ref);i++){
		  assign_reference * aref = (assign_reference *)assign->attributeValue(i,Assign_Ref);
		  SgArrayRefExp * array = (SgArrayRefExp *) aref->expression();
		  if(array->variant()==ARRAY_REF){
			  SgSymbol * arraysymb  = aref->expression()->symbol();
			  if(arraysymb->numberOfAttributes(Outofcore_Def)>0||aref->getCommunication()!=NONE){
			  	assign->controlParent()->setVariant(LOGIF_NODE);				break;	
			  }
		  }
	  }
  }
//add by huang finished!

  if (lhsaref->expression()->variant()==ARRAY_REF  && 
	lhsaref->getCommunication() != NONE ) 
  {
	assign = wrap_assign_on(assign);
  }

//add by huang 98.3.20
  for (i=0; i<assign->numberOfAttributes(OC_READ); i++) {
  	SgStatement *readst=(SgStatement *)assign->attributeValue(i, OC_READ);         
	assign->insertStmtBefore(*readst,*assign->controlParent());
  }
  for (i=0; i<assign->numberOfAttributes(OC_ASSIGN); i++) {
	  SgStatement *oc_write = (SgStatement *)assign->attributeValue(i, OC_ASSIGN);
  	  assign->insertStmtAfter(*oc_write,*assign->controlParent());
  }
//add by huang finished!

  if (need_wrap_on_clause())
  {
	SgStatement *newassign = wrap_by_on_clause(assign, assign->copyPtr());
	assign->insertStmtAfter(*newassign, *assign->controlParent());
	assign->deleteStmt();
  }
}


/**************************************************************************
	trans_pointer_assign process pointer assignstmt
**************************************************************************/

void trans_pointer_assign(SgStatement * s)
{
    SgExpression *lhs = s->expr(0);
    SgSymbol *lhsSymb = lhs->symbol();
    SgSymbol * lhsdad = s->getSymbolInCurrentScope(mixstring, "dad", lhsSymb->identifier());

    SgExpression *rhs = s->expr(1);
      // can not deal rhs as expression. 
    if(rhs->variant() != VAR_REF && rhs->variant() != ARRAY_REF)
    {
	printf("Sorry, cannot handle this kind of pointer assignment.\n");
	exit(1);
    }
    SgSymbol *rhsSymb = rhs->symbol();
    SgSymbol * rhsdad = s->getSymbolInCurrentScope(mixstring, "dad", rhsSymb->identifier());

    if (rhs->variant() == VAR_REF) {
	SgExpression *newlhs = new SgVarRefExp(lhsdad);
	SgExpression *newrhs = new SgVarRefExp(rhsdad);
	SgStatement *stmt = new SgAssignStmt(*newlhs, *newrhs);
	s->insertStmtBefore(*stmt, *s->controlParent());
    }
    else if (rhs->variant() == ARRAY_REF) {
	SgArrayRefExp *array = isSgArrayRefExp(rhs);
	int dim=0;
	for (int i=0; i<array->numberOfSubscripts(); i++)
		if (!array->isScalarOnDim(i)) dim++;
	SgStatement *sect = make_new_array_section(s, lhsdad, dim , rhsdad);
	s->insertStmtBefore(*sect, *s->controlParent());
    	define_array_from_arrayref(s, array, lhsdad);
    }
    s->deleteStmt();
}




